{-- Biblioteca que permite tocar um .wav em Haskell.  Importa a funo PlaySound
da API do Windows.  
 -- Autoria : Monique Louise de Barros Monteiro
 -- Novembro-2001
 --}

module Sound where

import Foreign
--import CForeign
import CString
import IOExts
import Bits
import Win32

data FDWSOUND
  = SND_APPLICATION
  | SND_ALIAS
  | SND_ALIAS_ID
  | SND_ASYNC
  | SND_FILENAME
  | SND_LOOP
  | SND_MEMORY
  | SND_NODEFAULT
  | SND_NOSTOP
  | SND_NOWAIT
  | SND_PURGE
  | SND_RESOURCE
  | SND_SYNC
  deriving ()
marshall_FDWSOUND :: FDWSOUND -> Word32
marshall_FDWSOUND arg1 = 
  case arg1 of {
     SND_APPLICATION -> ``SND_APPLICATION'';
     SND_ALIAS -> ``SND_ALIAS'';
     SND_ALIAS_ID -> ``SND_ALIAS_ID'';
     SND_ASYNC -> ``SND_ASYNC'';
     SND_FILENAME -> ``SND_FILENAME'';
     SND_LOOP -> ``SND_LOOP'';
     SND_MEMORY -> ``SND_MEMORY'';
     SND_NODEFAULT -> ``SND_NODEFAULT'';
     SND_NOSTOP -> ``SND_NOSTOP'';
     SND_NOWAIT -> ``SND_NOWAIT'';
     SND_PURGE -> ``SND_PURGE'';
     SND_RESOURCE -> ``SND_RESOURCE'';
     SND_SYNC -> ``SND_SYNC''
  }
  
marshall_FDWSOUNDLIST :: [FDWSOUND] -> Word32
marshall_FDWSOUNDLIST [] = 0
marshall_FDWSOUNDLIST (d:ds) = marshall_FDWSOUND d .|. marshall_FDWSOUNDLIST ds
  
foreign import ccall "PlaySound"  play :: CString -> Win32.HMODULE -> Word32 -> IO Bool

{--Parmetros:
 -> String filename : string que representa o nome do arquivo ou o caminho relativo
 		      para o nome do arquivo .wav
 -> Addr hmod :       manipulador para o arquivo executvel que contm o recurso a 
 		      ser carregado.  Tem que ser nullAddr ao menos que SND_RESOURCE
 		      especifique a instncia onde se encontra o recurso.  
 -> [FDWSOUND] flags : lista de flags para tocar o som	
--}
playSound :: String -> Win32.HMODULE -> [FDWSOUND] -> IO Bool
playSound filename hmod flags = play (unsafePerformIO (newCString filename)) hmod (marshall_FDWSOUNDLIST flags)
