{- 

HOpenGL Tutorial
http://www.cin.ufpe.br/~hopengl/
Copyright (C) 2002  Andre Furtado <awbf@cin.ufpe.br>

This code is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.

This is a HOpenGL example. Plese noticed that the code below is not optimized... I was just learning HOpenGL
when creating it (actually I'm still learning it :])

-}
import GL
import GLUT
import Random
import IOExts
import UserInput
import Awbfbmp
import Sound
foreign import shutdownHaskellAndExit :: Int -> IO ()

type Ship   = (IORef Bool,IORef Float,IORef Float,IORef Float,IORef Float,IORef Float,IORef Int) -- existance,X,Y,angle,speedX,speedY,turns left to re-appear
type Rock   = (IORef Bool,IORef Float,IORef Float,IORef Float,IORef Float,IORef Int,IORef Int,IORef RockType) -- existance,X,Y,speedX,speedY,state,rotate counter,type
type Shot   = (IORef Bool,IORef Float,IORef Float,IORef Float,IORef Float,IORef Int) -- existance,X,Y,speedX,speedY,turns left disappear
type Config = (IORef Bool,IORef GameState,IORef Bool,IORef Int, IORef Int) -- clear buffer, gameState, fullScreen, Level, aux counter
type SoundID = (IORef Bool,FilePath)

data Modif = Positive | Negative
data RockType = Small | Med | Big
data GameState = Begin | CreateShip | ExplodeShip | ActiveShip | ShowLevel
data SoundEvent = Start | Create | Shot | Hit | Explosion | NewLevel 
                  deriving Enum

invColor :: Maybe InvisibleColorList
invColor = Just [(0,0,0)]

frameRate,shipTurns,shotTurns,winX,winY,winWidth,winHeight,maxShots,iniRocks,maxRocks,levelCounter,rockCounter :: Int
frameRate 	= 50
shipTurns 	= 10
shotTurns 	= 15
winX 		= 100
winY 		= 100
winWidth 	= 800
winHeight 	= 600
maxShots 	= 20
iniRocks 	= 1
maxRocks 	= 200
levelCounter 	= 35
rockCounter     = 1

bigRockSize, medRockSize, smallRockSize,bigRockSpeed,medRockSpeed,smallRockSpeed,shotSpeed,shotSize,rotSpeed,shipSize,charSize,topS,bottomS,rightS,leftS :: Float
bigRockSize 	= 4.0
medRockSize 	= 2.0
smallRockSize 	= 1.0
bigRockSpeed 	= 1.0
medRockSpeed 	= 1.5
smallRockSpeed 	= 2.0
shotSpeed 	= 2.0
shotSize 	= 0.25
rotSpeed 	= 18.0
shipSize 	= 2.0
charSize 	= 1.5
topS 		= 30
bottomS 	= (-topS)
rightS 		= 40
leftS 		= (-rightS)

-- START OF SOUND ROUTINES --

getSoundID :: SoundEvent -> [SoundID] -> SoundID
getSoundID soundEvent soundStatus = soundStatus !! (fromEnum soundEvent)

checkSound :: (Bool,FilePath) -> IORef Bool -> [FDWSOUND] -> IO ()
checkSound (False,_) _ _ = return ()
checkSound (True,s) sE flags = playSound s nullAddr flags >>= \_ -> writeIORef sE False

sound :: SoundEvent -> [SoundID] -> [FDWSOUND] -> IO ()
sound sEvent sList flags = do
	let (sE,sP) = getSoundID sEvent sList
	sExist <- readIORef sE
	checkSound (sExist,sP) sE flags
	
setSoundIDTrue :: SoundEvent -> [SoundID] -> IO ()
setSoundIDTrue sEvent sList = do
	let (sE,_) = getSoundID sEvent sList
	writeIORef sE True
		
-- END OF SOUND ROUTINES --

display :: Ship -> [Shot] -> [Rock] -> Config -> ([TextureName],[TextureName],[TextureName],[TextureName],[TextureName]) -> [SoundID] -> DisplayAction
display ship shots rocks (cBuffer,gS,fS,gL,i) texs sounds = do
	gState <- readIORef gS
	displayAux gState ship shots rocks (cBuffer,gS,fS,gL,i) texs sounds
	
displayAux :: GameState -> Ship -> [Shot] -> [Rock] -> Config -> ([TextureName],[TextureName],[TextureName],[TextureName],[TextureName]) -> [SoundID] -> DisplayAction
displayAux Begin _ _ _ _ (texs,_,_,_,_) sounds = do
	clear [ColorBufferBit]
	enable Texture2d'
	bindTexture Texture2d (getL 3 texs)
	
	let texCoord2 :: GLfloat -> GLfloat -> IO ()
       	    texCoord2 x y = texCoord (TexCoord2 x y)
       	    vertex3 :: GLfloat -> GLfloat -> GLfloat -> IO ()
       	    vertex3 x y z = vertex (Vertex3 x y z)
	
	loadIdentity
	translate ( Vector3 0.0 0.0 ((-30.0) :: Float) )
	color (Color3 1.0 1.0 1.0 :: Color3 GLfloat)
				
	beginEnd Quads $ do
      		texCoord2 0.0 0.0;  vertex3 leftS  bottomS 0.0
		texCoord2 1.0 0.0;  vertex3 rightS bottomS 0.0
      		texCoord2 1.0 1.0;  vertex3 rightS topS    0.0
		texCoord2 0.0 1.0;  vertex3 leftS  topS    0.0
      			
	disable Texture2d'
	swapBuffers
	flush
	sound Start sounds [SND_ASYNC]

displayAux ActiveShip ship shots rocks (cBuffer,gS,_,gL,_) (bmTexs,rockbTex,rockmTex,rocksTex,_) sounds = do
	cb <- readIORef cBuffer
	checkBuffer cb
	moveShip ship
	moveShots shots
	moveRocks rocks
	shotCollision shots rocks sounds
	shipCollision ship rocks rocks gS sounds
	drawShip  ship  (head bmTexs)
	drawShots shots (getL 2 bmTexs)
	drawRocks rocks (rockbTex,rockmTex,rocksTex)
	isClear <- levelClear rocks
	nextLevel isClear ship shots rocks gS gL sounds
	loadIdentity
	swapBuffers
	flush
	
	sound Create sounds [SND_ASYNC]
	sound Hit    sounds [SND_ASYNC,SND_NOSTOP]
	sound Shot   sounds [SND_ASYNC]
	
displayAux ExplodeShip ship@(_,_,_,_,_,_,sT) shots rocks (cBuffer,gS,_,_,_) (bmTexs,rockbTex,rockmTex,rocksTex,_) sounds = do
	cb <- readIORef cBuffer
	checkBuffer cb
	moveShip ship
	moveShots shots
	shotCollision shots rocks sounds
	moveRocks rocks
	drawShip  ship  (getL 4 bmTexs)
	drawShots shots (getL 2 bmTexs)
	drawRocks rocks (rockbTex,rockmTex,rocksTex)
	updateIORef sT (\w -> w - 1)
	shipT <- readIORef sT
	checkNewChip shipT ship gS
	loadIdentity
	swapBuffers
	flush
	sound Explosion sounds [SND_ASYNC]
	sound Hit       sounds [SND_ASYNC,SND_NOSTOP]
	
displayAux CreateShip _ shots rocks (cBuffer,_,_,_,_) (bmTexs,rockbTex,rockmTex,rocksTex,_) sounds = do	
	cb <- readIORef cBuffer
	checkBuffer cb
	moveShots shots
	moveRocks rocks
	drawShots shots (getL 2 bmTexs)
	drawRocks rocks (rockbTex,rockmTex,rocksTex)
	loadIdentity
	swapBuffers
	flush
	sound Hit sounds [SND_ASYNC,SND_NOSTOP]
	
displayAux ShowLevel _ _ _ (cBuffer,gS,_,gL,i) (bmTexs,_,_,_,nmTexs) sounds = do
	cb <- readIORef cBuffer
	checkBuffer cb
	updateIORef i (\w -> w - 1)
	counter <- readIORef i
	gameLevel <- readIORef gL
	checkCounter counter i gS
	drawLevel gameLevel ((getL 5 bmTexs),(getL 6 bmTexs),(getL 7 bmTexs)) nmTexs
	swapBuffers
	flush
	sound NewLevel sounds [SND_ASYNC]
	
checkCounter :: Int -> IORef Int -> IORef GameState -> IO ()
checkCounter 0 i gS = do
	writeIORef gS CreateShip
	writeIORef i levelCounter
checkCounter _ _ _ = return ()	
	
checkNewChip :: Int -> Ship -> IORef GameState -> IO ()
checkNewChip 0 ship gS = do
	initShip ship
	writeIORef gS CreateShip
checkNewChip _ _ _ = return ()

checkBuffer :: Bool -> IO ()
checkBuffer False = return ()
checkBuffer True  = clear [ColorBufferBit]
	
nextLevel :: Bool -> Ship -> [Shot] -> [Rock] -> IORef GameState -> IORef Int -> [SoundID] -> IO ()
nextLevel False _ _ _ _ _ _ = return ()
nextLevel True ship shots rocks gS gL sounds = do
	updateIORef gL (\w -> w + 1)
	writeIORef gS ShowLevel
	gLevel <- readIORef gL
	initShip ship
	initShots shots
	initRocks rocks ( (2 * gLevel) - 1 )
	setSoundIDTrue NewLevel sounds
	
initShots :: [Shot] -> IO ()
initShots [] = return ()
initShots ((sE,_,_,_,_,_):ss) = do
	writeIORef sE False
	initShots ss
	
initRocks :: [Rock] -> Int -> IO ()
initRocks _ 0 = return()
initRocks rList n = do
	a <- getFloat ( (leftS + bigRockSize),(rightS - bigRockSize) )
	b <- getFloat ( (bottomS + bigRockSize),(topS - bigRockSize) )
	insertRock (a,b,Big) rList
	initRocks rList (n-1)

initShip :: Ship -> IO ()
initShip (sE,sX,sY,sA,ssX,ssY,sT) = do
	writeIORef sE  True
	writeIORef sX  0.0
	writeIORef sY  0.0
	writeIORef sA  90.0
	writeIORef ssX 0.0
	writeIORef ssY 0.0
	writeIORef sT  shipTurns
	
levelClear :: [Rock] -> IO Bool -- checks if all rocks are destroyed
levelClear [] = return (True)
levelClear (r:rs) = do
	rockE <- readIORef (fst8 r)
	case (rockE) of
		True  -> return (False)
		False -> levelClear rs
	 
shipCollision :: Ship -> [Rock] -> [Rock] -> IORef GameState -> [SoundID] -> IO () -- checks collision between the ship vs. all rocks
shipCollision _ [] _ _ _ = return ()
shipCollision ship (r:rs) rList gS sounds = do
	rockE <- readIORef (fst8 r)
	shipE <- readIORef (fst7 ship)
	oneRockCol (rockE && shipE) ship r rList gS sounds
	shipCollision ship rs rList gS sounds
				
oneRockCol :: Bool -> Ship -> Rock -> [Rock] -> IORef GameState -> [SoundID] -> IO () -- checks collision between the ship vs. ONE rock
oneRockCol False _ _ _ _ _ = return ()
oneRockCol True (sE,sX,sY,sA,ssX,ssY,sT) (rE,rX,rY,rsX,rsY,rS,rC,rT) rList gS sounds = do
	rockT <- readIORef rT
	isCol <- hitShip rockT (sX,sY,rX,rY)
	analyseShipCol isCol rockT (sE,sX,sY,sA,ssX,ssY,sT) (rE,rX,rY,rsX,rsY,rS,rC,rT) rList gS
	setSoundIDTrue Explosion sounds
		
analyseShipCol :: Bool -> RockType -> Ship -> Rock -> [Rock] -> IORef GameState -> IO ()
analyseShipCol False _ _ _ _ _ = return ()
analyseShipCol True Big (sE,_,_,_,_,_,_) (_,rX,rY,rsX,rsY,rS,rC,rT) rList gS = do
	writeIORef sE False
	writeIORef gS ExplodeShip
	rspeedX <- getFloat ((-medRockSpeed), medRockSpeed)
	rspeedY <- getFloat ((-medRockSpeed), medRockSpeed)
	writeIORef rsX rspeedX
	writeIORef rsY rspeedY
	rockX <- readIORef rX
	rockY <- readIORef rY
	writeIORef rS 1
	writeIORef rC rockCounter
	writeIORef rT Med
	insertRock (rockX,rockY,Med) rList
analyseShipCol True Med (sE,_,_,_,_,_,_) (_,rX,rY,rsX,rsY,rS,rC,rT) rList gS = do
	writeIORef sE False
	writeIORef gS ExplodeShip
	rspeedX <- getFloat ((-smallRockSpeed), smallRockSpeed)
	rspeedY <- getFloat ((-smallRockSpeed), smallRockSpeed)
	writeIORef rsX rspeedX
	writeIORef rsY rspeedY
	rockX <- readIORef rX
	rockY <- readIORef rY
	writeIORef rS 1
	writeIORef rC rockCounter
	writeIORef rT Small
	insertRock (rockX,rockY,Small) rList
analyseShipCol True Small (sE,_,_,_,_,_,_) (rE,_,_,_,_,_,_,_) _ gS = do
	writeIORef gS ExplodeShip
	writeIORef sE False
	writeIORef rE False
	
hitShip	 :: RockType -> (IORef Float,IORef Float,IORef Float,IORef Float) -> IO Bool
hitShip Big (sX,sY,rX,rY) = do
	shipX <- readIORef sX
	shipY <- readIORef sY
	rockX <- readIORef rX
	rockY <- readIORef rY
	return ( (shipX < rockX + bigRockSize + shipSize) &&
		 (shipX > rockX - bigRockSize - shipSize) &&
		 (shipY < rockY + bigRockSize + shipSize) &&
		 (shipY > rockY - bigRockSize - shipSize) )
hitShip Med (sX,sY,rX,rY) = do
	shipX <- readIORef sX
	shipY <- readIORef sY
	rockX <- readIORef rX
	rockY <- readIORef rY
	return ( (shipX < rockX + medRockSize + shipSize) &&
		 (shipX > rockX - medRockSize - shipSize) &&
		 (shipY < rockY + medRockSize + shipSize) &&
		 (shipY > rockY - medRockSize - shipSize) )
hitShip Small (sX,sY,rX,rY) = do
	shipX <- readIORef sX
	shipY <- readIORef sY
	rockX <- readIORef rX
	rockY <- readIORef rY
	return ( (shipX < rockX + smallRockSize + shipSize) &&
		 (shipX > rockX - smallRockSize - shipSize) &&
		 (shipY < rockY + smallRockSize + shipSize) &&
		 (shipY > rockY - smallRockSize - shipSize) )		

shotCollision :: [Shot] -> [Rock] -> [SoundID] -> IO () -- checks collision between all shots vs. all rocks
shotCollision [] _ _ = return ()
shotCollision (s:ss) rocks sounds = do
	shotE <- readIORef (fst6 s)
	oneShotCol shotE s rocks rocks sounds
	shotCollision ss rocks sounds

oneShotCol :: Bool -> Shot -> [Rock] -> [Rock] -> [SoundID] -> IO () -- checks collision between ONE shot vs. all rocks
oneShotCol False _ _  _ _ = return()
oneShotCol _     _ [] _ _ = return()
oneShotCol True (sE,sX,sY,ssX,ssY,sT) ((rE,rX,rY,rsX,rsY,rS,rC,rT):rs) rList sounds = do
	rockE <- readIORef rE
	rockT <- readIORef rT
	isCol <- hitShot rockE rockT (sX,sY,rX,rY)
	analyseShotCol isCol rockT (sE,sX,sY,ssX,ssY,sT) (rE,rX,rY,rsX,rsY,rS,rC,rT) rList sounds
	shotE <- readIORef sE
	oneShotCol shotE (sE,sX,sY,ssX,ssY,sT) rs rList sounds
	
analyseShotCol :: Bool -> RockType -> Shot -> Rock -> [Rock] -> [SoundID] -> IO () -- split the rock if collision has happened
analyseShotCol False _ _ _ _ _ = return ()
analyseShotCol True Big (sE,_,_,_,_,_) (_,rX,rY,rsX,rsY,rS,rC,rT) rList sounds = do
	writeIORef sE False
	rspeedX <- getFloat ((-medRockSpeed), medRockSpeed)
	rspeedY <- getFloat ((-medRockSpeed), medRockSpeed)
	writeIORef rsX rspeedX
	writeIORef rsY rspeedY
	rockX <- readIORef rX
	rockY <- readIORef rY
	writeIORef rS 1
	writeIORef rC rockCounter
	writeIORef rT Med
	insertRock (rockX,rockY,Med) rList
	setSoundIDTrue Hit sounds
analyseShotCol True Med (sE,_,_,_,_,_) (_,rX,rY,rsX,rsY,rS,rC,rT) rList sounds= do
	writeIORef sE False
	rspeedX <- getFloat ((-smallRockSpeed), smallRockSpeed)
	rspeedY <- getFloat ((-smallRockSpeed), smallRockSpeed)
	writeIORef rsX rspeedX
	writeIORef rsY rspeedY
	rockX <- readIORef rX
	rockY <- readIORef rY
	writeIORef rS 1
	writeIORef rC rockCounter
	writeIORef rT Small
	insertRock (rockX,rockY,Small) rList
	setSoundIDTrue Hit sounds
analyseShotCol True Small (sE,_,_,_,_,_) (rE,_,_,_,_,_,_,_) _ sounds = do
	writeIORef sE False
	writeIORef rE False
	setSoundIDTrue Hit sounds
		
insertRock :: (Float,Float,RockType) -> [Rock] -> IO ()
insertRock _ [] = return()
insertRock (rockX,rockY,rockT) (r:rs) = do
	rockE <- readIORef (fst8 r)
	insertRockAux rockE (rockX,rockY,rockT) r rs

insertRockAux :: Bool -> (Float,Float,RockType) -> Rock -> [Rock] -> IO()
insertRockAux True a _ rs = insertRock a rs  -- rock cannot be inserted here; another one already exists in this place
insertRockAux False (rockX,rockY,rockT) (rE,rX,rY,rsX,rsY,rS,rC,rT) _ = do
	writeIORef rE True
	writeIORef rX rockX
	writeIORef rY rockY
	rspeedX <- getFloat (checkSpeed rockT)
	rspeedY <- getFloat (checkSpeed rockT)
	writeIORef rsX rspeedX
	writeIORef rsY rspeedY
	writeIORef rS 1
	writeIORef rC rockCounter
	writeIORef rT rockT

checkSpeed :: RockType -> (Float,Float)
checkSpeed Small = ((-smallRockSpeed), smallRockSpeed)
checkSpeed Med   = ((-medRockSpeed), medRockSpeed)
checkSpeed Big   = ((-bigRockSpeed), bigRockSpeed)

hitShot :: Bool -> RockType -> (IORef Float,IORef Float,IORef Float,IORef Float) -> IO Bool
hitShot False _ _ = return (False)
hitShot True Big (sX,sY,rX,rY) = do
	shotX <- readIORef sX
	shotY <- readIORef sY
	rockX <- readIORef rX
	rockY <- readIORef rY
	return ( (shotX < rockX + bigRockSize + shotSize) &&
		 (shotX > rockX - bigRockSize - shotSize) &&
		 (shotY < rockY + bigRockSize + shotSize) &&
		 (shotY > rockY - bigRockSize - shotSize) )
hitShot True Med (sX,sY,rX,rY) = do
	shotX <- readIORef sX
	shotY <- readIORef sY
	rockX <- readIORef rX
	rockY <- readIORef rY
	return ( (shotX < rockX + medRockSize + shotSize) &&
		 (shotX > rockX - medRockSize - shotSize) &&
		 (shotY < rockY + medRockSize + shotSize) &&
		 (shotY > rockY - medRockSize - shotSize) )
hitShot True Small (sX,sY,rX,rY) = do
	shotX <- readIORef sX
	shotY <- readIORef sY
	rockX <- readIORef rX
	rockY <- readIORef rY
	return ( (shotX < rockX + smallRockSize + shotSize) &&
		 (shotX > rockX - smallRockSize - shotSize) &&
		 (shotY < rockY + smallRockSize + shotSize) &&
		 (shotY > rockY - smallRockSize - shotSize) )

moveShip :: Ship -> IO ()
moveShip (_,x,y,a,sx,sy,_) = do
	shipX  <- readIORef x
	shipY  <- readIORef y
	shipA  <- readIORef a
	speedX <- readIORef sx
	speedY <- readIORef sy
	
	let nx2 = shipX + speedX
	    ny2 = shipY + speedY
	updateIORef sx (\w -> if ((nx2 + shipSize > rightS) || (nx2 - shipSize < leftS)) then (-w) else w)
	updateIORef sy (\w -> if ((ny2 + shipSize > topS) || (ny2 - shipSize < bottomS)) then (-w) else w)
	
	sx2 <- readIORef sx
	sy2 <- readIORef sy
	
	writeIORef x (shipX + sx2)
	writeIORef y (shipY + sy2)
	

moveRocks :: [Rock] -> IO ()
moveRocks [] = return ()
moveRocks ((rE,rX,rY,rsX,rsY,rS,rC,rT):rs) = do
			rockE <- readIORef rE
			moveRocksAux rockE (rE,rX,rY,rsX,rsY,rS,rC,rT)
			moveRocks rs
			
moveRocksAux :: Bool -> Rock -> IO ()
moveRocksAux False _ = return ()
moveRocksAux _ (_,rX,rY,rsX,rsY,rS,rC,rT) = do
	rockX <- readIORef rX
	rockY <- readIORef rY
	rockT <- readIORef rT
	rSize <- checkRockSize rockT
	updateIORef rsX (\w -> if ((w + rockX + rSize > rightS) || (w + rockX - rSize < leftS)) then (-w) else w)
	updateIORef rsY (\w -> if ((w + rockY + rSize > topS) || (w + rockY - rSize < bottomS)) then (-w) else w)
	
	speedX <- readIORef rsX
	speedY <- readIORef rsY
		
	updateIORef rX (\w -> w + speedX)
	updateIORef rY (\w -> w + speedY)
	updateIORef rC (\w -> if (w - 1 == 0) then rockCounter else (w - 1) )
	counter  <- readIORef rC
	preState <- readIORef rS
	writeIORef rS (if (counter == rockCounter) then (upgradeState preState rockT) else preState)
	
upgradeState :: Int -> RockType -> Int
upgradeState 30 Big   = 1
upgradeState 40 Med   = 1
upgradeState  1 Small = 1
upgradeState  n _     = n + 1

checkRockSize :: RockType -> IO Float
checkRockSize Small = return (smallRockSize)
checkRockSize Med   = return (medRockSize)
checkRockSize Big   = return (bigRockSize)

moveShots :: [Shot] -> IO ()
moveShots [] = return ()
moveShots ((sE,sX,sY,ssX,ssY,sT):ss) = do
			shotE <- readIORef sE
			moveShotsAux shotE (sE,sX,sY,ssX,ssY,sT)
			moveShots ss
			
moveShotsAux :: Bool -> Shot -> IO ()
moveShotsAux False _ = return ()
moveShotsAux _ (sE,sX,sY,ssX,ssY,sT) = do
	shotX <- readIORef sX
	shotY <- readIORef sY
	updateIORef ssX (\w -> if ((w + shotX > rightS) || (w + shotX  < leftS)) then (-w) else w)
	updateIORef ssY (\w -> if ((w + shotY > topS) || (w + shotY  < bottomS)) then (-w) else w)
	
	speedX <- readIORef ssX
	speedY <- readIORef ssY
	
	updateIORef sX (\w -> w + speedX)
	updateIORef sY (\w -> w + speedY)
	updateIORef sT (\w -> w - 1)
	shotT <- readIORef sT
	writeIORef sE (if (shotT == 0) then False else True)

drawLevel :: Int -> (TextureName,TextureName,TextureName) -> [TextureName] -> IO ()
drawLevel lev (texL,texE,texV) texN = do
	drawChar texL (-12)
	drawChar texE (-9)
	drawChar texV (-6)
	drawChar texE (-3)
	drawChar texL 0
	drawChar (head texN) 6
	drawChar (head texN) 9
	drawChar (getTex (getL 1 level0) texN) 6
	drawChar (getTex (getL 2 level0) texN) 9
	drawChar (getTex (getL 3 level0) texN) 12
	where   level0 = (make0 (3-(length level))) ++ level
		level = (show lev)
		
getTex :: Char -> [TextureName] -> TextureName
getTex _ [] = error "texture list empty"
getTex n texN = getL ( ( ((fromEnum n) - (fromEnum '0')) `mod` 10) + 1) texN
		
drawChar :: TextureName -> Float -> IO ()
drawChar tex posX = do
	enable Texture2d'
	bindTexture Texture2d tex
	let texCoord2 :: GLfloat -> GLfloat -> IO ()
	    texCoord2 u v = texCoord (TexCoord2 u v)
	    vertex3 :: GLfloat -> GLfloat -> GLfloat -> IO ()
       	    vertex3 u v w = vertex (Vertex3 u v w)
       	loadIdentity
	translate ( Vector3 posX 0 ((-30.0)::Float) )
	color (Color3 1.0 1.0 1.0 :: Color3 GLfloat)
	beginEnd Quads $ do
      		texCoord2 0.0 0.0;  vertex3 (-charSize)   (-charSize)   0.0
		texCoord2 1.0 0.0;  vertex3   charSize    (-charSize)   0.0
      		texCoord2 1.0 1.0;  vertex3   charSize      charSize    0.0
		texCoord2 0.0 1.0;  vertex3 (-charSize)     charSize    0.0
      			
	disable Texture2d'
	
drawShip :: Ship -> TextureName -> IO ()
drawShip (_,x,y,a,_,_,_) texShip = do
	shipX <- readIORef x
	shipY <- readIORef y
	shipA <- readIORef a

	enable Texture2d'
	bindTexture Texture2d texShip
				
	let texCoord2 :: GLfloat -> GLfloat -> IO ()
	    texCoord2 u v = texCoord (TexCoord2 u v)
	    vertex3 :: GLfloat -> GLfloat -> GLfloat -> IO ()
       	    vertex3 u v w = vertex (Vertex3 u v w)
				
	loadIdentity
	translate ( Vector3 shipX shipY (-30.0) )
	rotate shipA (Vector3 0.0 0.0 1.0)
				
	color (Color3 1.0 1.0 1.0 :: Color3 GLfloat)
				
	beginEnd Quads $ do
      		texCoord2 0.0 0.0;  vertex3 (-shipSize)   (-shipSize)   0.0
		texCoord2 1.0 0.0;  vertex3   shipSize    (-shipSize)   0.0
      		texCoord2 1.0 1.0;  vertex3   shipSize      shipSize    0.0
		texCoord2 0.0 1.0;  vertex3 (-shipSize)     shipSize    0.0
      			
	disable Texture2d'		

drawRocks :: [Rock] -> ([TextureName],[TextureName],[TextureName]) -> IO ()
drawRocks [] _ = return ()
drawRocks rList rtexs = do
	rockE <- readIORef (fst8(head rList))
	drawRocksAux rockE rList rtexs
			
drawRocksAux :: Bool -> [Rock] -> ([TextureName],[TextureName],[TextureName]) -> IO ()
drawRocksAux False (_:rs) t = drawRocks rs t
drawRocksAux True ((_,rX,rY,_,_,rS,_,rT):rs) rtexs = do
				
	rockX <- readIORef rX
	rockY <- readIORef rY
	rockS <- readIORef rS
	rockT <- readIORef rT
	
	
	enable Texture2d'
	rSize <- chooseTexAndSize rockT rtexs rockS
	
	
	let texCoord2 :: GLfloat -> GLfloat -> IO ()
 	    texCoord2 x y = texCoord (TexCoord2 x y)
	    vertex3 :: GLfloat -> GLfloat -> GLfloat -> IO ()
 	    vertex3 x y z = vertex (Vertex3 x y z)
				
	loadIdentity
	translate ( Vector3 rockX rockY (-30.0) )
					
	color (Color3 1.0 1.0 1.0 :: Color3 GLfloat)
				
	beginEnd Quads $ do
      		texCoord2 0.0 0.0;  vertex3 (-rSize)   (-rSize)   0.0
		texCoord2 1.0 0.0;  vertex3   rSize    (-rSize)   0.0
      		texCoord2 1.0 1.0;  vertex3   rSize      rSize    0.0
		texCoord2 0.0 1.0;  vertex3 (-rSize)     rSize    0.0
   			
	disable Texture2d'
	drawRocks rs rtexs
drawRocksAux _ _ _ = return ()							
			
chooseTexAndSize :: RockType -> ([TextureName],[TextureName],[TextureName]) -> Int -> IO (Float)
chooseTexAndSize Big   (rb,_,_) n = bindTexture Texture2d (getL n rb) >> return (bigRockSize)
chooseTexAndSize Med   (_,rm,_) n = bindTexture Texture2d (getL n rm) >> return (medRockSize)
chooseTexAndSize Small (_,_,rs) n = bindTexture Texture2d (getL n rs) >> return (smallRockSize)
			
drawShots :: [Shot] -> TextureName -> IO ()
drawShots [] _ = return ()
drawShots sList texShot = do
	shotE <- readIORef (fst6(head sList))
	drawShotsAux shotE sList texShot	
			
drawShotsAux :: Bool -> [Shot] -> TextureName -> IO ()
drawShotsAux False (_:ss) t = drawShots ss t
drawShotsAux True ((_,sX,sY,_,_,_):ss) texShot = do
				
	shotX <- readIORef sX
	shotY <- readIORef sY
				
	enable Texture2d'
	bindTexture Texture2d texShot
				
	let texCoord2 :: GLfloat -> GLfloat -> IO ()
	    texCoord2 x y = texCoord (TexCoord2 x y)
	    vertex3 :: GLfloat -> GLfloat -> GLfloat -> IO ()
	    vertex3 x y z = vertex (Vertex3 x y z)
				
	loadIdentity
	translate ( Vector3 shotX shotY (-30.0) )
								
	color (Color3 1.0 1.0 1.0 :: Color3 GLfloat)
	
	beginEnd Quads $ do
		texCoord2 0.0 0.0;  vertex3 (-shotSize)   (-shotSize)   0.0
		texCoord2 1.0 0.0;  vertex3   shotSize    (-shotSize)   0.0
		texCoord2 1.0 1.0;  vertex3   shotSize      shotSize    0.0
		texCoord2 0.0 1.0;  vertex3 (-shotSize)     shotSize    0.0
      			
	disable Texture2d'
	drawShots ss texShot
drawShotsAux _ _ _ = return ()				

getL :: Int -> [t] -> t
getL _ [] = error "get list error: list empty"
getL 1 (a:_) = a
getL n as = getL (n-1) (tail as)
			      
toRad :: Float -> Float
toRad a = ((pi * a)/180)

fst6 :: (a,b,c,d,e,f) -> a
fst6 (a,_,_,_,_,_) = a

fst7 :: (a,b,c,d,e,f,g) -> a
fst7 (a,_,_,_,_,_,_) = a

fst8 :: (a,b,c,d,e,f,g,h) -> a
fst8 (a,_,_,_,_,_,_,_) = a

getFloat :: (Float,Float) -> IO Float
getFloat (a,b) = randomRIO (a,b)
   	
createRocks :: Int -> [Rock] -> IO [Rock]
createRocks a rocks = createRocksAux a maxRocks rocks

createRocksAux :: Int -> Int -> [Rock] -> IO [Rock]
createRocksAux _ 0 rList = return (rList)
createRocksAux 0 n rList = do
	rockE <- newIORef False
	rockX <- newIORef 0.0
	rockY <- newIORef 0.0
	rspeedX <- newIORef 0.0
	rspeedY <- newIORef 0.0
	rockS   <- newIORef 1
	rockC   <- newIORef 0
	rockT   <- newIORef Big
	createRocksAux 0 (n-1) ((rockE,rockX,rockY,rspeedX,rspeedY,rockS,rockC,rockT):rList)
createRocksAux r n rList = do
	rockE <- newIORef True
	a <- getFloat ( (leftS + bigRockSize),(rightS - bigRockSize) )
	rockX <- newIORef a
	b <- getFloat ( (bottomS + bigRockSize),(topS - bigRockSize) )
	rockY <- newIORef b
	c <- getFloat ((-bigRockSpeed), bigRockSpeed)
	rspeedX <- newIORef c
	d <- getFloat ((-bigRockSpeed), bigRockSpeed)
	rspeedY <- newIORef d
	rockC <- newIORef rockCounter
	rockS <- newIORef 1
	
	rockT   <- newIORef Big
	createRocksAux (r-1) (n-1) ((rockE,rockX,rockY,rspeedX,rspeedY,rockS,rockC,rockT):rList)
	
createShots :: Int -> [Shot] -> IO [Shot]
createShots 0 sList = return (sList)
createShots n sList = do
	shotE   <- newIORef False
	shotX   <- newIORef 0.0
	shotY   <- newIORef 0.0
	sspeedX <- newIORef 0.0
	sspeedY <- newIORef 0.0
	shotT   <- newIORef 0
	createShots (n-1) ((shotE,shotX,shotY,sspeedX,sspeedY,shotT):sList)
				
createShip :: IO (Ship)
createShip = do
	shipE  <- newIORef True
	shipX  <- newIORef 0.0
	shipY  <- newIORef 0.0
	shipA  <- newIORef 90.0
	speedX <- newIORef 0.0
	speedY <- newIORef 0.0
	shipT  <- newIORef shipTurns
	return (shipE,shipX,shipY,shipA,speedX,speedY,shipT)	
	
initGame :: IO (Config)
initGame = do
	cBuffer <- newIORef True
	gState  <- newIORef Begin
	fScreen <- newIORef False
	gLevel  <- newIORef 1
	count   <- newIORef levelCounter
	return (cBuffer,gState,fScreen,gLevel,count)

awbfBindings :: Ship -> [Shot] -> Config -> [SoundID] -> IO (KeyBinder, StillDownHandler)
awbfBindings ship@(_,x,y,a,sx,sy,_) sList (cBuffer,gState,fScreen,_,_) sounds = do
				
	(bindKey, stillDown) <- initUserInput
	
	bindKey (KeySpecial KeyLeft  ) StillDown (Just (turn Positive a gState))
	bindKey (KeySpecial KeyRight ) StillDown (Just (turn Negative a gState))
	bindKey (KeySpecial KeyUp    ) StillDown (Just (accel Positive ship gState))
	bindKey (KeySpecial KeyDown  ) StillDown (Just (accel Negative ship gState))
	bindKey (KeySpecial KeyEnd   ) Press     (Just (do writeIORef sx 0.0; writeIORef sy 0.0))
	bindKey (KeySpecial KeyF5    ) Press     (Just (changeScreenMode fScreen))
	bindKey (KeySpecial KeyF1    ) Press     (Just (changeBufferMode cBuffer gState))
	bindKey (KeyNormal '\r'      ) Press	 (Just (processEnter gState sounds))
	bindKey (KeyNormal '\32'     ) Press	 (Just (setSoundIDTrue Shot sounds))
	bindKey (KeyNormal '\32'     ) StillDown (Just (addShot sList (x,y,a) gState))				
	bindKey (KeyNormal '\27'     ) Press     (Just (shutdownHaskellAndExit 1))
	bindKey (KeySpecial KeyF12   ) Press     (Just (shutdownHaskellAndExit 1))
	return (bindKey, stillDown)

changeBufferMode :: IORef Bool -> IORef GameState -> IO ()
changeBufferMode cB gS = do
	gState <- readIORef gS
	changeBufferModeAux cB gState
	
changeBufferModeAux :: IORef Bool -> GameState -> IO ()	
changeBufferModeAux _ Begin = return ()
changeBufferModeAux cB _ = updateIORef cB (\w -> not w)
	
changeScreenMode :: IORef Bool -> IO ()
changeScreenMode fS = do
	fScreen <- readIORef fS
	changeScreenModeAux fScreen
	updateIORef fS (\w -> not w)

changeScreenModeAux :: Bool -> IO ()
changeScreenModeAux False = fullScreen
changeScreenModeAux True  = reshapeWindow (WindowSize winWidth winHeight) >> positionWindow (WindowPosition winX winY)

processEnter :: IORef GameState -> [SoundID] -> IO ()
processEnter gS sounds = do
	gameState <- readIORef gS
	processEnterAux gameState gS sounds

processEnterAux :: GameState -> IORef GameState -> [SoundID] -> IO ()
processEnterAux Begin gS sounds = do
	writeIORef gS ShowLevel
	setSoundIDTrue NewLevel sounds
processEnterAux CreateShip gS sounds = do
	writeIORef gS ActiveShip
	setSoundIDTrue Create sounds
processEnterAux _ _ _ = return ()	

turn :: Modif -> IORef Float -> IORef GameState -> IO ()
turn m a gS = do
	gState <- readIORef gS
	turnAux m a gState

turnAux :: Modif -> IORef Float -> GameState -> IO ()
turnAux Positive a ActiveShip = updateIORef a (\w -> if (w + (rotSpeed) == 360) then 0.0 else (w + (rotSpeed)))
turnAux Negative a ActiveShip = updateIORef a (\w -> if (w == 0) then (360.0 - rotSpeed) else (w - (rotSpeed)))
turnAux _ _ _ = return ()

accel :: Modif -> Ship -> IORef GameState -> IO ()
accel m s gS = do
	gState <- readIORef gS
	accelAux m s gState
		
accelAux :: Modif -> Ship -> GameState -> IO ()
accelAux Positive (_,x,y,a,sx,sy,_) ActiveShip = do
	shipA <- readIORef a
	shipX <- readIORef x
	shipY <- readIORef y
	updateIORef sx (\w -> w + (cos (toRad shipA))/4)
	updateIORef sy (\w -> w + (sin (toRad shipA))/4)
accelAux Negative (_,x,y,a,sx,sy,_) ActiveShip = do
	shipA <- readIORef a
	shipX <- readIORef x
	shipY <- readIORef y
	updateIORef sx (\w -> w - (cos (toRad shipA))/4)
	updateIORef sy (\w -> w - (sin (toRad shipA))/4)
accelAux _ _ _ = return ()

addShot :: [Shot] -> (IORef Float,IORef Float,IORef Float) -> IORef GameState -> IO ()
addShot a b gS = do
	gState <- readIORef gS
	addShot2 a b gState

addShot2 :: [Shot] -> (IORef Float,IORef Float,IORef Float) -> GameState -> IO ()
addShot2 [] _ ActiveShip = return ()
addShot2 sList (x,y,a) ActiveShip = do
	shotE <- readIORef (fst6(head sList))
	addShotAux shotE sList (x,y,a)
addShot2 _ _ _ = return ()

addShotAux :: Bool -> [Shot] -> (IORef Float,IORef Float,IORef Float) -> IO ()
addShotAux _ [] _ = return()
addShotAux True (_:ss) p = addShot2 ss p ActiveShip
addShotAux False ((sE,sX,sY,ssX,ssY,sT):_) (x,y,a) = do
	shotX <- readIORef x
	shotY <- readIORef y
	shipA <- readIORef a
	writeIORef sE True
	writeIORef sX  (shotX + shipSize * (cos(toRad shipA)) )
	writeIORef sY  (shotY + shipSize * (sin(toRad shipA)) )
	writeIORef ssX (shotSpeed * (cos(toRad shipA)) )
	writeIORef ssY (shotSpeed * (sin(toRad shipA)) )
	writeIORef sT shotTurns
		
timer :: StillDownHandler -> TimerAction
timer stillDown = do
	stillDown
	postRedisplay
	timerFunc frameRate (timer stillDown)

reshape :: ReshapeAction
reshape screenSize@(WindowSize w h) = do
   viewport (WindowPosition 0 0) screenSize
   matrixMode Projection
   loadIdentity
   let	near   = 1
	far    = 80
	fov    = 90
	ang    = (fov*pi)/(360 :: Double)
	top    = near / ( cos(ang) / sin(ang) )
	aspect = fromIntegral(w)/fromIntegral(h)
	right = top*aspect
   frustum (-right) right (-top) top near far
   matrixMode Modelview		

texStuff :: [TextureName] -> [AwbfBitmap] -> IO ()
texStuff [] _ = return ()
texStuff (t:ts) ((bmW,bmH,bmData):bms) = do
	bindTexture Texture2d t
	texImage2D Texture2d 0 GL.Rgba' bmW bmH 0 bmData
	texParameter Texture2d (TextureFilters Nearest Nearest)
	texStuff ts bms
texStuff _ _ = return ()

myInit :: IO ([TextureName],[TextureName],[TextureName],[TextureName],[TextureName])
myInit = do
	clearColor (Color4 0 0 0 0)
	clear [ColorBufferBit]
	shadeModel GL.Flat
	matrixMode Projection
  	loadIdentity
	matrixMode Modelview
	loadIdentity
	enable Blend'
   	blendFunc SrcAlpha OneMinusSrcAlpha
	bmps  <- loadBitmapList (addInv ["ship.bmp","shot.bmp","begin.bmp","explos.bmp","l.bmp","e.bmp","v.bmp"])
	nums  <- loadBitmapList (addInv ["0.bmp","1.bmp","2.bmp","3.bmp","4.bmp","5.bmp","6.bmp","7.bmp","8.bmp","9.bmp"])
	rockb <- loadBitmapList (addInv ["rockb01.bmp","rockb02.bmp","rockb03.bmp","rockb04.bmp","rockb05.bmp",
			     "rockb06.bmp","rockb07.bmp","rockb08.bmp","rockb09.bmp","rockb10.bmp",
			     "rockb11.bmp","rockb12.bmp","rockb13.bmp","rockb14.bmp","rockb15.bmp",
			     "rockb16.bmp","rockb17.bmp","rockb18.bmp","rockb19.bmp","rockb20.bmp",
			     "rockb21.bmp","rockb22.bmp","rockb23.bmp","rockb24.bmp","rockb25.bmp",
			     "rockb26.bmp","rockb27.bmp","rockb28.bmp","rockb29.bmp","rockb30.bmp"])
	rockm <- loadBitmapList (addInv ["rockm01.bmp","rockm02.bmp","rockm03.bmp","rockm04.bmp","rockm05.bmp",
			     "rockm06.bmp","rockm07.bmp","rockm08.bmp","rockm09.bmp","rockm10.bmp",
			     "rockm11.bmp","rockm12.bmp","rockm13.bmp","rockm14.bmp","rockm15.bmp",
			     "rockm16.bmp","rockm17.bmp","rockm18.bmp","rockm19.bmp","rockm20.bmp",
			     "rockm21.bmp","rockm22.bmp","rockm23.bmp","rockm24.bmp","rockm25.bmp",
			     "rockm26.bmp","rockm27.bmp","rockm28.bmp","rockm29.bmp","rockm30.bmp",
			     "rockm31.bmp","rockm32.bmp","rockm33.bmp","rockm34.bmp","rockm35.bmp",
			     "rockm36.bmp","rockm37.bmp","rockm38.bmp","rockm39.bmp","rockm40.bmp"])
	rocks <- loadBitmapList (addInv ["rocks.bmp"])
	
	texBmList <- (genTextures (length bmps ) )
	texStuff texBmList bmps
	texNmList <- (genTextures (length nums ) )
	texStuff texNmList nums
	texRbList <- (genTextures (length rockb) )
	texStuff texRbList rockb
	texRmList <- (genTextures (length rockm) )
	texStuff texRmList rockm
	texRsList <- (genTextures (length rocks) )
	texStuff texRsList rocks
	
	
	return (texBmList,texRbList,texRmList,texRsList,texNmList)

addInv :: [FilePath] -> [(FilePath,Maybe InvisibleColorList)]
addInv [] = []
addInv (a:as) = (a,invColor):(addInv as)

{-genList :: Int -> (Integer,Integer) -> (Integer,Integer) -> [((Integer,Integer),(Integer,Integer))]
genList 0 _ _ = []
genList n (x0,xInc) (y0,y1) = (((x0,y0),((x0+xInc),y1)): genList (n-1) ((x0+xInc),xInc) (y0,y1))
-}

initSoundStatus :: IO [SoundID]
initSoundStatus = do
	start <- newIORef True 
	create <- newIORef False
	shot <- newIORef False
	hit <- newIORef False
	explosion <- newIORef False
	newLevel <- newIORef False
	return ((start,"start.wav"):(create,"create.wav"):(shot,"shot.wav"):(hit,"hit.wav"):(explosion,"explosion.wav"):(newLevel,"newlevel.wav"):[])

main :: IO ()
main = do
	GLUT.init Nothing
	ship   <- createShip
	shots  <- createShots maxShots []
	rocks  <- createRocks iniRocks []
	config <- initGame
	sounds <- initSoundStatus
	createWindow "Haskell Space Donuts - by Andre Furtado" (return ()) [ GLUT.Double, GLUT.Rgba ]
                (Just (WindowPosition winX     winY      ))
                (Just (WindowSize     winWidth winHeight ))
	texs <- myInit
	(bindKey, stillDown) <- awbfBindings ship shots config sounds
	displayFunc (display ship shots rocks config texs sounds)
	timerFunc frameRate (timer stillDown)
	reshapeFunc (Just reshape)
   	mainLoop